@phdthesis{lipinski,
	author = {M. Lipiński},
	title = {Methods to Increase Reliability and Ensure Determinism in a White Rabbit Network},
	school = {Warsaw University of Technology},
	year = {2016}}

@mastersthesis{wlostowski,
	author = {T. Włostowski},
	title = {{Precise time and frequency transfer in a White Rabbit network}},
	school = {Warsaw University of Technology},
	year = {2011}}

@mastersthesis{daniluk,
	author = {G. Daniluk},
	title = {{White Rabbit PTP Core the sub-nanosecond time synchronization over Ethernet}},
	school = {Warsaw University of Technology},
	year = {2012}}

@article{space,
	author = {M. {Jamroży} and M. {Gumiński} and G. {Kasprowicz} and R. {Romaniuk} and K. {Poźniak}},
	year = {2015},
	title = {{White Rabbit in Space Related Application}},
	journal = {Proceedings of SPIE - The International Society for Optical Engineering}}

@misc{wr-standard,
	title = {{White Rabbit, a CERN-born technology, sets a new global standard}},
	howpublished = {\\\url{https://home.cern/news/news/knowledge-sharing/white-rabbit-cern-born-technology-sets-new-global-standard}},
	year = {(accessed \today)}}

@misc{wr-wiki,
	title = {{White Rabbit project wiki homepage}},
	howpublished = {\\\url{https://ohwr.org/project/white-rabbit/wikis/home}},
	year = {(accessed \today)}}

@misc{wr-wiki-collab,
	title = {{Companies involved in White Rabbit}},
	howpublished = {\\\url{https://www.ohwr.org/projects/white-rabbit/wiki/wrcompanies}},
	year = {(accessed \today)}}

@misc{wr-wiki-users,
	title = {{Users of White Rabbit Technology}},
	howpublished = {\\\url{https://www.ohwr.org/projects/white-rabbit/wiki/WRUsers}},
	year = {(accessed \today)}}

@misc{wrs-wiki-v3,
	title = {{White Rabbit Switch Hardware v3 wiki homepage}},
	howpublished = {\\\url{https://ohwr.org/project/wr-switch-hw/wikis/home}},
	year = {(accessed \today)}}

@misc{wrs-wiki-v4,
	title = {{White Rabbit Switch Hardware v4 wiki homepage}},
	howpublished = {\\\url{https://ohwr.org/project/wr-switch-hw-v4/wikis/home}},
	year = {(accessed \today)}}

@techreport{sevelsols-report,
	title       = {{Hardware specifications of the White Rabbit Switch version 4}},
	institution = {Seven Solutions},
	number      = {version 1.1},
	year        = {2021}}

@article{ieee8021q,
	author={},
	journal={{IEEE Std 802.1Q-2014 (Revision of IEEE Std 802.1Q-2011)}}, 
	title={{IEEE Standard for Local and metropolitan area networks--Bridges and Bridged Networks}}, 
	year={2014}}

@misc{rfc2889,
	title = "{{RFC 2889, Benchmarking Methodology for LAN Switching Devices}}",
	howpublished =	{},
	type="{RFC}",
	number=2889,
	year = {2000},
	institution = "{RFC Editor}"}

@misc{rfc2544,
	series =	{Request for Comments},
	number =	2544,
	howpublished =	{},
	publisher =	{RFC Editor},
	author =	{},
	title =		{{RFC 2544, Benchmarking Methodology for Network Interconnect Devices}},
	year =		1999}




@book{all-switch,
	title     = {The All-New Switch Book: The Complete Guide to LAN Switching Technology, Second Edition},
	author    = {R. {Seifert} and J. {Edwards}},
	year      = {2008},
	publisher = {Wiley}}

@book{ethernet-switches,
	title     = {Ethernet Switches: An Introduction to Network Design with Switches},
	author    = {J. {Zimmerman} and C.E. {Spurgeon}},
	year      = {2013},
	publisher = {O'Reilly Media}}


@article{gigabit-switch,
	author={M.V. {Lau} and S. {Shieh} and W. {Pei-Feng} and  B. {Smith} and D. {Lee} and J. {Chao} and B. {Shung} and S. {Cheng-Chung}},
	journal={IEEE Communications Magazine}, 
	title={{Gigabit Ethernet Switches Using a Shared Buffer Architecture}}, 
	year={2003}}

@inproceedings{optimizing-lookup,
	author={T. {Ganegedara} and V. {Prasanna} and G. {Brebner}},
	booktitle={22nd International Conference on Field Programmable Logic and Applications (FPL)}, 
	title={{Optimizing Packet Lookup in Time and Space on FPGA}}, 
	year={2012}}

@inproceedings{ultra-fast,
	author = {S.V. {Makov} and V.I. {Marchuk} and V.V. {Voronin} and V.A. {Frantc} and V.A. {Obukhovets}},
	title = {{A method for ultra fast searching within traffic filtering tables in networking hardware}},
	booktitle = {Visual Information Processing and Communication VI},
	publisher = {SPIE},
	year = {2015}}




@inproceedings{cam,
	author={A.J. {McAuley} and P. {Francis}},
	booktitle={IEEE INFOCOM '93 The Conference on Computer Communications, Proceedings}, 
	title={{Fast Routing Table Lookup Using CAMs}}, 
	year={1993}}

@inproceedings{tcam-lpm,
	author={A. {Rasmussen} and A. {Kragelund} and M. {Berger} and H. {Wessing} and S. {Ruepp}},
	booktitle={2013 IEEE 14th International Conference on High Performance Switching and Routing (HPSR)}, 
	title={{TCAM-based high speed longest prefix matching with fast incremental table updates}}, 
	year={2013}}

@inproceedings{tcam-bram,
	author={A.M.S. {Abdelhadi} and G.G.F. {Lemieux} and L. {Shannon}},
	booktitle={2018 28th International Conference on Field Programmable Logic and Applications (FPL)}, 
	title={{Modular Block-RAM-Based Longest-Prefix Match Ternary Content-Addressable Memories}}, 
	year={2018}}

@inproceedings{tcam-scalable-ram,
	author={W. {Jiang}},
	booktitle={Architectures for Networking and Communications Systems}, 
	title={{Scalable Ternary Content Addressable Memory implementation using FPGAs}}, 
	year={2013}}

@article{pram,
	author = {R. {Karp} and M. {Luby} and F. {Meyer auf der Heide}},
	year = {1998},
	title = {{Efficient PRAM Simulation on a Distributed Memory Machine}},
	journal = {Algorithmica}}

@misc{cam-xilinx,
	title = {{Application Note: Parameterizable Content-Addressable Memory}},
	howpublished = {\\\url{https://www.xilinx.com/support/documentation/application_notes/xapp1151_Param_CAM.pdf}},
	year = {(accessed \today)}}




@inproceedings{multilevel,
	author = {A. {Broder} and A. {Karlin}},
	year = {1990},
	title = {{Multilevel Adaptive Hashing}},
	booktitle = {Conference: Proceedings of the First Annual ACM-SIAM Symposium on Discrete Algorithms}}

@article{birthday-problem,
	author = {M. Sayrafiezadeh},
	journal = {Mathematics Magazine},
	title = {{The Birthday Problem Revisited}},
	year = {1994}}

@inproceedings{effect,
	author={C. {Huntley} and G. {Antonova} and P. {Guinand}},
	booktitle={Proceedings. 2006 31st IEEE Conference on Local Computer Networks}, 
	title={{Effect of Hash Collisions on the Performance of LAN Switching Devices and Networks}}, 
	year={2006}}

@book{aoc,
	author = {D.E. Knuth},
	title = {The Art of Computer Programming, Volume 3: (2nd Ed.) Sorting and Searching},
	year = {1998},
	publisher = {Addison Wesley Longman Publishing Co., Inc.}}

@inproceedings{asymmetry-load-balancing,
	author={Vocking, B.},
	booktitle={40th Annual Symposium on Foundations of Computer Science}, 
	title={How asymmetry helps load balancing}, 
	year={1999}}

@article{balanced-allocations,
	author = {Y. {Azar} and A. {Broder} and E. {Upfal}},
	year = {2001},
	title = {{Balanced Allocations}},
	journal = {SIAM J Comput}}

@article{two-choices,
	author={M. Mitzenmacher},
	journal={IEEE Transactions on Parallel and Distributed Systems}, 
	title={The power of two choices in randomized load balancing}, 
	year={2001}}

@inproceedings{multiple-hash-ip-lookup,
	author = {A. {Broder} and M. {Mitzenmacher}},
	year = {2001},
	title = {{Using Multiple Hash Functions to Improve IP Lookups}},
	booktitle = {Proceedings IEEE INFOCOM 2001. Conference on Computer Communications}}

@inproceedings{worst-case-constant,
	author = {D. {Fotakis} and R. {Pagh} and P. {Sanders} and P. {Spirakis}},
	year = {2003},
	booktitle= {STACS 2003 20th Annual Symposium on Theoretical Aspects of Computer Science Berlin},
	title = {{Space Efficient Hash Tables with Worst Case Constant Access Time}}}

@article{cuckoo,
	title = {Cuckoo hashing},
	journal = {Journal of Algorithms},
	year = {2004},
	author = {P. {Rasmus} and F.R. {Flemming}}}

@inproceedings{segmented-hash,
	author={S. {Kumar} and P. {Crowley}},
	booktitle={2005 Symposium on Architectures for Networking and Communications Systems (ANCS)}, 
	title={{Segmented Hash: An Efficient Hash Table Implementation for High Performance Networking Subsystems}}, 
	year={2005}}

@inproceedings{peacock,
	author={S. {Kumar} and J. {Turner} and P. {Crowley}},
	booktitle={IEEE INFOCOM 2008 - The 27th Conference on Computer Communications}, 
	title={{Peacock Hashing: Deterministic and Updatable Hashing for High Performance Networking}}, 
	year={2008}}

@inproceedings{flashlook,
	author={M. {Bando} and N.S. {Artan} and H.J. {Chao}},
	booktitle={2009 International Conference on High Performance Switching and Routing}, 
	title={{FlashLook: 100-Gbps Hash-Tuned Route Lookup Architecture}}, 
	year={2009}}

@inproceedings{high-speed,
	author={A. {Kirsch} and M. {Mitzenmacher} and G. {Varghese}},
	title={{Hash-Based Techniques for High-Speed Packet Processing}},
	booktitle={{Algorithms for Next Generation Networks}},
	year={2010}}

@article{one-move,
	author={A. {Kirsch} and M. {Mitzenmacher}},
	journal={IEEE/ACM Transactions on Networking}, 
	title={{The Power of One Move: Hashing Schemes for Hardware}}, 
	year={2010}}

@article{emoma,
	author = {S. {Pontarelli} and P. {Reviriego} and M. {Mitzenmacher}},
	year = {2017},
	title = {{EMOMA: Exact Match in One Memory Access}},
	journal = {IEEE Transactions on Knowledge and Data Engineering}}

@article{sdn,
	author = {P. {Bosshart} and G. {Gibb} and H.S. {Kim} and G. {Varghese} and N. {McKeown} and M. {Izzard} and F. {Mujica} and M. {Horowitz}},
	year = {2013},
	title = {{Forwarding Metamorphosis: Fast Programmable Match-Action Processing in Hardware for SDN}},
	journal = {ACM SIGCOMM Computer Communication Review}}


@article{bloom-summary,
	author={{Li Fan} and {Pei Cao} and J. {Almeida} and A.Z. {Broder}},
	journal={IEEE/ACM Transactions on Networking}, 
	title={{Summary Cache: A Scalable Wide-Area Web Cache Sharing Protocol}}, 
	year={2000}}

@article{fht-bloom,
	author = {H. {Song} and S. {Dharmapurikar} and J. {Turner} and J. {Lockwood}},
	year = {2005},
	title = {{Fast Hash Table Lookup Using Extended Bloom Filter: An Aid to Network Processing}},
	journal = {ACM SIGCOMM Computer Communication Review}}

@article{bloom-scalable,
	title = {{Scalable Bloom Filters}},
	journal = {Information Processing Letters},
	year = {2007},
	author = {P. S. {Almeida} and C. {Baquero} and N. {Preguiça} and D. {Hutchison}}}

@inproceedings{hash-ip-lookup-scalable-bloom,
	author={H. {Yu} and R. {Mahapatra} and L. {Bhuyan}},
	booktitle={2009 17th IEEE International Conference on Network Protocols}, 
	title={{A Hash-based Scalable IP lookup using Bloom and Fingerprint Filters}}, 
	year={2009}}

@article{bloom-count,
	author = {D. {Guo} and Y. {Liu} and X. {Li} and P. {Yang}},
	year = {2010},
	title = {{False Negative Problem of Counting Bloom Filter}},
	journal = {Knowledge and Data Engineering, IEEE Transactions on}}

@inproceedings{bloom,
	author={J. M. {Cho} and K. {Choi}},
	booktitle={Technical Papers of 2014 International Symposium on VLSI Design, Automation and Test}, 
	title={{An FPGA Implementation of High-Throughput Key-Value Store Using Bloom Filter}}, 
	year={2014}}




@article{parallel-d-pipeline,
	author={S. {Pontarelli} and P. {Reviriego} and J.A. {Maestro}},
	journal={IEEE Transactions on Computers}, 
	title={{Parallel d-Pipeline: A Cuckoo Hashing Implementation for Increased Throughput}}, 
	year={2016}}

@article{fasthash,
	title={{FASTHash: FPGA-Based High Throughput Parallel Hash Table}},
	author={Y. {Yang} and S. {Kuppannagari} and A. {Srivastava} and R. {Kannan} and V. {Prasanna}},
	journal={High Performance Computing},
	year={2020},
	title = {{The Power of Two Random Choices: A Survey of Techniques and Results}}}



@article{hash-function,
	author={Jain, R.},
	journal={IEEE Transactions on Communications}, 
	title={{A Comparison of Hashing schemes for Address Lookup in Computer Networks}}, 
	year={1992}}

@misc{crc,
	author = {D. {Alnajjar} and M. {Suguiy}},
	year = {2015},
	title = {{A Comprehensive Guide for CRC Hardware Implementation}}}



@misc{wrs-hdl-sw,
	title = {{White Rabbit Switch HDL software interface version 4.0}},
	author = {G. Daniluk},
	howpublished = {\\\url{https://ohwr.org/project/wr-switch-hdl/wikis/Documents/White-Rabbit-Switch-HDL-SW-interface}},
	year = {(accessed \today)}}

@misc{ultrascale-memory,
	title = {{UltraScale Architecture Memory Resources, User Guide}},
	howpublished = {\\\url{https://www.xilinx.com/support/documentation/user_guides/ug573-ultrascale-memory-resources.pdf}},
	year = {(accessed \today)}}

@misc{ultrascale-datasheet,
	title = {{Zynq UltraScale+ MPSoC Data Sheet: DC and AC Switching Characteristics}},
	howpublished = {\\\url{https://www.xilinx.com/support/documentation/data_sheets/ds925-zynq-ultrascale-plus.pdf}},
	year = {(accessed \today)}}

@misc{ultrascale-eval,
	author = {M. Gumiński},
	title = {{WRS resource utilisation on Xilinx US+ FPGA}},
	howpublished = {\\\url{https://ohwr.org/project/wr-switch-hw-v4/wikis/uploads/31c7019f3c24cb12ec0f8c79c108af59/WRS-v4-resource-utilization.pdf}},
	year = {(accessed \today)}}
